(ns hello-spa-navigation.core
  (:require
   [accountant.core :as accountant]
   [clerk.core :as clerk]
   [goog.dom :as gdom]
   [goog.string :as gstr]
   [reagent.core :as r]
   [reagent.dom :as rdom]
   [reagent.format :as f]
   [reagent.session :as session]
   [reitit.frontend :as rfe]
   [reitit.frontend.easy :as rfee]))


;; A complete example of dispatching, routing and navigation in an SPA

(enable-console-print!)
(println "SPA dispatching, routing and navigation: core guide")


;; an application: components, routes, etc

(def router
  "Allows to find page names/parameters by path and vice versa."
  (rfe/router
   [["/" :index]
    ["/items"
     ["" :items]
     ["/:item-id" :item]]
    ["/about" :about]]))

(def lorem "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do
  eiusmod tempor incididunt ut labore et dolore magna aliqua. Quis eleifend quam
  adipiscing vitae proin sagittis nisl. Facilisi etiam dignissim diam quis. Nibh
  ipsum consequat nisl vel pretium lectus quam id leo. Aliquam eleifend mi in
  nulla posuere. Platea dictumst vestibulum rhoncus est. Nisl condimentum id
  venenatis a condimentum vitae sapien pellentesque. Risus at ultrices mi tempus
  imperdiet nulla malesuada. Felis donec et odio pellentesque diam volutpat
  commodo sed egestas. Nisl nunc mi ipsum faucibus vitae aliquet nec. Aliquam
  etiam erat velit scelerisque in. Habitant morbi tristique senectus et
  netus. Suspendisse interdum consectetur libero id faucibus. Ipsum faucibus
  vitae aliquet nec ullamcorper sit amet risus. Non diam phasellus vestibulum
  lorem sed risus.")

(defn lorem-ipsum
  "Creates `n` paragraphs of `text` with anchor links."
  [n text]
  (let [nbsp (gstr/unescapeEntities "&nbsp;")]
    [:div#lorem-top.lorem-ipsum
     (for [i (range n)]
       [:a {:href (str "#lorem-" i) :key i} (str "lorem-" i nbsp)])
     [:a {:href "#lorem-bottom"} "bottom"]
     [:br][:hr]
     (for [i (range n)]
       [:<> {:key i}
        [:a {:href (str "/items/" i)
             :id   (str "lorem-" i)}[:b "Lorem " i nbsp]]
        [:a {:href "#lorem-top"} "top" nbsp]
        [:a {:href "#lorem-bottom"} "bottom" nbsp]
        [:p text]])
     [:hr]
     (for [i (range n)]
       [:a {:href (str "#lorem-" i) :key i} (str "lorem-" i nbsp)])
     [:a#lorem-bottom {:href "#lorem-top"} "top"]]))


(defn index-page []
  [:div "Index"])

(defn items-page []
  [:div "Items: in-page navigation demo (anchors)"
   [lorem-ipsum 10 lorem]])

(defn item-page [{:keys [path-params]}]
  (let [item-index (:item-id path-params)]
    [:div "Item " item-index
     [:hr]
     [:p lorem]
     [:hr]]))

(defn about-page [{:keys [path-params query-params fragment]}]
  [:div#about-top "About"
   [:hr]
   [:p "Path params: " path-params]
   [:p "Query params: " query-params]
   [:p "Fragment: " fragment]
   [:a {:href "#about-top"} "Top"]
   [:hr]])

(defn not-found-page []
  [:div "Not found"
   [:hr]])

(defn page-for [route]
  (case route
    :index #'index-page
    :items #'items-page
    :item #'item-page
    :about #'about-page
    #'not-found-page))

(defn mount-root
  "Mount reagent component `c` into DOM and render it."
  [c]
  (rdom/render c (gdom/getElement "app")))


;; basic flow

;; 1. listening to navigation events (e.g. user clicks a link or enters URL in
;;    address bar) and passing them to router: Accountant or Reitit
;;    (frontend.easy)
;; 2. routing (determining page name and parameters from the path): Reitit
;;    (frontend)
;; 3. navigation to the selected page (and proper scrolling within the page):
;;    Clerk


;; Accountant, Reitit, Clerk

(defn path-for
  "Returns a path for the route name."
  [route & [params]]
  (if params
    (:path (rfe/match-by-name router route params))
    (:path (rfe/match-by-name router route))))

(defn app-accountant-reitit-clerk []
  (fn []
    (let [route       (session/get :route)
          page        (:current-page route)]
      [:div
       [:header
        [:p [:a {:href (path-for :index)} "Index"] " | "
         [:a {:href (path-for :items)} "Items"] " | "
         [:a {:href (str (path-for :about) "?test=aye")} "About"]]]
        [page route]
       [:footer
        [:p "generated by the "
         [:a {:href "https://github.com/reagent-project/reagent-template"}
          "Reagent Template"] "."]]])))

(defn init-accountant-reitit-clerk!
  "Start the app using Accountant, Reitit and Clerk."
  []
  (clerk/initialize!)
  (accountant/configure-navigation!
   {:nav-handler
    (fn [path]
      (println "Navigating to" path)
      (let [match        (rfe/match-by-path router path)
            current-page (:name (:data  match))
            path-params  (:path (:parameters match))
            query-params (:query (:parameters match))
            fragment     (:fragment (:parameters match))]
        (f/printf "Path params: %s, query params: %s, fragment: %s\n"
                path-params query-params fragment)
        (r/after-render clerk/after-render!)
        (session/put! :route {:current-page (page-for current-page)
                              :path-params  path-params
                              :query-params query-params
                              :fragment     fragment})
        (clerk/navigate-page! path)))
    :path-exists?
    (fn [path]
      (boolean (rfe/match-by-path router path)))})
  (accountant/dispatch-current!)
  (mount-root [app-accountant-reitit-clerk]))


;; Reitit, Clerk

(defn app-reitit-clerk []
  (fn []
    (let [route       (session/get :route)
          page        (:current-page route)]
      [:div
       [:header
        [:p [:a {:href (rfee/href :index)} "Index"] " | "
         [:a {:href (rfee/href :items)} "Items"] " | "
         [:a {:href (rfee/href :about nil {:test "yar"})} "About"]]]
       [page route]
       [:footer
        [:p "generated by the "
         [:a {:href "https://github.com/reagent-project/reagent-template"}
          "Reagent Template"] "."]]])))

(defn init-reitit-clerk!
  "Start the app using only Reitit and Clerk."
  []
  (clerk/initialize!)
  (rfee/start!
   router
   (fn [{:keys [data parameters path-params path] :as match} history]
     (println "Navigating to" path)
     (let [current-page             (:name  data)
           {:keys [query fragment]} parameters
           path-with-fragment       (str path
                                         (when fragment (str "#" fragment)))]
       (f/printf "Path params: %s, query params: %s, fragment: %s\n"
                 path-params query fragment)
       (r/after-render clerk/after-render!)
       (session/put! :route {:current-page (page-for current-page)
                             :path-params  path-params
                             :query-params query
                             :fragment     fragment})
       (clerk/navigate-page! path-with-fragment)))
   {:use-fragment false})
  (mount-root [app-reitit-clerk]))


(comment

  (init-accountant-reitit-clerk!)

  (init-reitit-clerk!)

)
